
//*****************************************************************************
//
// File Name	: 'main.c'
// Title		: SPI interface driven E0855-2 SED1530 graphic LCD
// Author		: Marc Meise
// Created		: December 2007
// Version		: Beta
// Target MCU	: NXP LPC210x
//
//
// This code is distributed under the GNU Public License
// which can be found at http://www.gnu.org/licenses/gpl.txt
//
//*****************************************************************************

/*  Just a small Test-Program to demonstrate the functions of the E0855-2 SED1530 driver.
	The GLCD is connected via SPI.
	The software SPI is used.
	Development-Environment was the Olimex-board LPC-P2103 with WINARM 4.1.1
	
	Please feel free to modify the driver to your own purpose.

	Disclaimer:I will not take any responsibility or what so ever for the functionality of the E0855-2 SED1530 driver.
	If you wreck anything - it's your own business...
	Modify this code and contribute freely.
*/

// BUT is congured as a switch to step through the demo.
// I think that the command-functions are fairly self explanatory and are therefore not commented.

//Have fun!


#include "lpc2103.h"
#include <inttypes.h>
#include "SED1530ARM.h"
#include "font.h"
#include "PICS.h"
unsigned char count=0;

void pressbutton (void);
void Pagecount(void);

int main (void)
{
const char a[]="Press BUT to";
const char b[]="step through the";
const char c[]="demo of the GLCD";
const char d[]="****************";
 IODIR=0xFFFFFFFF;
 IOSET=0xFFFFFFFF;
 MAM_MAMCR = 2;
 MAM_MAMTIM=1;	
 IODIR&=~(1<<15);
 IOSET=(1<<9);
 Init_SED1530();
 SED_contrast (14);
 SED_clear();
 SED_puts(a);
 SED_newline();
 SED_puts(b);
 SED_newline();
 SED_puts(c);
 SED_set_XY(0,0);
 SED_puts(d);
 SED_symbol(19,1);
 Pagecount();

while (1)
{
 pressbutton();
 SED_clear();
 Pagecount();
 SED_set_XY(3,10);
 SED_puts("This is a DEMO");
 SED_set_XY(2,15); 
 SED_puts("of the GLCD");
 SED_set_XY(1,27);
 SED_puts("E0855-2");
 SED_set_XY(0,27);
 SED_puts("*******");
 SED_symbol(63,1);
 
 pressbutton();
 
 SED_clear_page(0);
 Pagecount();
 SED_set_XY(0,1);
 SED_puts("A Number: ");
 SED_puts_num(54321);
 SED_symbol(63,0);
 SED_symbol(36,1);
 SED_symbol(96,1);
 SED_symbol(95,1);
 SED_symbol(97,1);
 SED_symbol(98,1);

 pressbutton();
 Pagecount();
 SED_showPIC (1);
 SED_symbol(98,0);
 SED_symbol(36,0);

 pressbutton();
 Pagecount();
 SED_showPIC (2);
 SED_symbol(96,1);
 SED_symbol(95,1);
 SED_symbol(97,0);

 pressbutton();
 SED_clear();
 Pagecount();
 unsigned char x;
 for (x=0; x<=95; x++)
 	{
 	 SED_pixel(x, 0, 0x01);	 
	 SED_pixel(x, 3, 0x80);
	}
 for (x=0; x<=3; x++)
 	{
 	 SED_pixel(0, x, 0xFF);	 
	 SED_pixel(95, x, 0xFF);
	}

 SED_set_XY(2,8);
 SED_puts("Frame and Bar");
 SED_pixel(7, 1, 0x7E);
 SED_pixel(86, 1,0x7E);
 for(x=8; x<=85;x++)
 {
  SED_pixel(x, 1, 0xFF);
 }

  for(x=9; x<=84;x++)
 {
  SED_pixel(x, 1, 0x81);
  delay();
 }
 SED_set_XY(2,8);
 SED_puts("  Press BUT  ");

 pressbutton();
 Pagecount();
 SED_pixel(7, 1, 0x00);
 SED_pixel(86, 1,0x00);

 for(x=8; x<=85;x++)
 {
  SED_pixel(x, 1, 0xFF);
  SED_pixel(x, 2, 0xFF);
 }

  for(x=84; x>=50;x--)
 {
  SED_pixel(x, 1, 0x01);
  SED_pixel(x, 2, 0x80);
  delay();
 }

  for(x=9; x<=49;x++)
 {
  SED_pixel(x, 1, 0x01);
  SED_pixel(x, 2, 0x80);
  delay();
 }
 delay();

 SED_clear();
 Pagecount();
 SED_symbol(96,1);
 SED_puts("Going to sleep");
 SED_newline();
 SED_puts("Press BUT!");
 SED_newline();
 SED_puts("Press BUT again");
 SED_newline();
 SED_puts("to wake-up!");
 SED_symbol(36,1);
 pressbutton();
 IOCLR=(1<<9);
 SED_sleep();

 pressbutton();
 IOSET=(1<<9);
 SED_wakeup();
 SED_clear();
 Pagecount();
 SED_puts("SED1530 Woke-up!");
 SED_newline();
 SED_newline();
 SED_puts("Press BUT again");
 SED_newline();
 SED_puts("to continue demo");
 pressbutton();

 unsigned char smbl;
 SED_contrast (14);
 SED_clear();
 for (smbl=19; smbl<=99; smbl++)
 	{
	 SED_symbol(smbl,1);
	}
 SED_set_XY(2,0);
 SED_puts(" All Symbols ON ");
 SED_set_XY(0,74);
 const char end[]="END";
 SED_puts(end);
 count=1;
} 
 return(0);
}


void pressbutton (void)
{
 while (!( IOPIN & (1<<15)))
 {
 delay();
 }
 while ( IOPIN & (1<<15)) ; 
 delay();
}

void Pagecount(void)
{
 SED_7segment(0,count);
 count++;
}